
#ifndef COMMON_DEFINES_H
#define COMMON_DEFINES_H

#define TRUE	1
#define FALSE	0

#define MAX_RAILS 10
#define DELIMITER ":"

#define DEMO_ONLY	'0'
#define PS_ONLY		'1'
#define PL_ONLY		'2'
#define PS_AND_PL	'3'
#define KILL_APP	'F'

#define FREQ_222	'3'	//SOC13xEOC
#define FREQ_333	'2' //SOC12xEOC
#define FREQ_667	'1' //SOC11xEOC

#define CPU_LOAD_1	'1' //SOC1x1EOC = idle
#define CPU_LOAD_2	'2' //SOC1x2EOC = spec2000 1 cpu
#define CPU_LOAD_3	'3' //SOC1x3EOC = spec2000 2 cpu
#define CPU_LOAD_4	'4' //SOC1x4EOC = CPU standby Mode

#define BUF_MAX 1024
#define MAX_CPU 2
#define MAX_PROCESS 10 //We assume we are not going to have more than 10 apps running

typedef struct rail
{
	float voltage;
	float current;
	float power;
}rail_info;

struct response
{
	rail_info rail[MAX_RAILS];
	float cpu_freq;
	float ddr_freq;
	float cpu0_util;
	float cpu1_util;
	float total_power;
	float max_power;
}pd_response;

typedef struct command
{
	char start_of_command[3];
	char test_num;
	char cpu_freq;
	char cpu_load;
	char PL_freq;
	char PL_load;
	char PL_Config;
	char PL_INIT;
	char end_of_command[3];
}type_command;

type_command *rxvd_command;

int rxvd_char;
int run_command;

char command_buffer[200];
char response_buffer[1000];
char error_buffer[200];
char temp_string[30];


extern const char START_CMD[4];
extern const char END_CMD[4];
extern const char ERROR_RESPONSE[4];
extern const char START_OF_RESPONSE[4];
extern const char END_OF_RESPONSE[4];


#endif

