
#include "common_defines.h"
#include "output.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>


void *ProcessResponseOutput(void)
{
	//while((*(int*)pParam == 1))
	while(1)
	{
		//error_print("Task Running........\n");
		//sample current, voltage
		//calculate power
		//populate structure
		SamplePMBus();
		ReadAdditionalData();
		ReadCpuUtilization();

		//send it out
		SendResponse();
	}
}

void SendResponse()
{
	int cur_rail;

	//add start of response
	strcpy(response_buffer, START_OF_RESPONSE);
	strcat(response_buffer, DELIMITER);

	//add the rail voltage, current and power info
	for(cur_rail=0;cur_rail < MAX_RAILS;cur_rail++)
	{
		sprintf(temp_string, "%.2f", pd_response.rail[cur_rail].voltage);
		strcat(response_buffer, temp_string);
		strcat(response_buffer, DELIMITER);
		sprintf(temp_string, "%.2f", pd_response.rail[cur_rail].current);
		strcat(response_buffer, temp_string);
		strcat(response_buffer, DELIMITER);
		sprintf(temp_string, "%.2f", pd_response.rail[cur_rail].power);
		strcat(response_buffer, temp_string);
		strcat(response_buffer, DELIMITER);
	}

	//add additional special status
	sprintf(temp_string, "%.2f", pd_response.cpu_freq);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);
	sprintf(temp_string, "%.2f", pd_response.ddr_freq);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);
	sprintf(temp_string, "%.2f", pd_response.cpu0_util);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);
	sprintf(temp_string, "%.2f", pd_response.cpu1_util);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);
	sprintf(temp_string, "%.2f", pd_response.total_power);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);
	sprintf(temp_string, "%.2f", pd_response.max_power);
	strcat(response_buffer, temp_string);
	strcat(response_buffer, DELIMITER);

	//add end of response
	strcat(response_buffer, END_OF_RESPONSE);
	strcat(response_buffer, "\r\n");

	//send it out on UART
	printf("%s", response_buffer);
}


void error_print(char *error)
{
	strcpy(error_buffer, ERROR_RESPONSE);
	strcat(error_buffer, error);
	strcat(error_buffer, END_OF_RESPONSE);
	strcat(error_buffer, "\r\n");
	printf("%s", error_buffer);
	//usleep( 500 * 1000 );
}

void buzz_print(char *buzz_msg)
{
	strcpy(error_buffer, "BUZZS");
	strcat(error_buffer, buzz_msg);
	strcat(error_buffer, "BUZZE");
	strcat(error_buffer, "\r\n");
	printf("%s", error_buffer);
}

